#include <vector>
#include <iostream>
#include <cstdlib>
#include <ctime>
#include <cmath>
using namespace std;

struct Input {
    vector<double> numbers;
    size_t bin_count{};
};

Input
input_data() {
    Input in;
    size_t number_count;
    cerr << "Enter number count: ";
    cin >> number_count;
    in.numbers.resize(number_count);
    for (size_t i = 0; i < number_count; i++) {
        cin >> in.numbers[i];
    }
    size_t bin_count;
    cerr << "Enter bin count: ";
    cin >> in.bin_count;
    return in;
}

void
find_minmax(const vector<double>& numbers, double& min, double& max) {
    min = numbers[0];
    max = numbers[0];
    for (double x : numbers) {
        if (x < min) {
            min = x;
        }
        else if (x > max) {
            max = x;
        }
    }
}


int main() {
    const size_t SCREEN_WIDTH = 80;
    const size_t MAX_ASTERISK = SCREEN_WIDTH - 3 - 1;
    Input in = input_data();
    vector<size_t> bins(in.bin_count, 0);

    double min, max;
    find_minmax(in.numbers, min, max);


    double bin_size = (max - min) / in.bin_count;

    for (size_t i = 0; i < in.numbers.size(); i++) {
        bool found = false;
        for (size_t j = 0; (j < in.bin_count - 1) && !found; j++) {
            auto lo = min + j * bin_size;
            auto hi = min + (j + 1) * bin_size;
            if ((lo <= in.numbers[i]) && (in.numbers[i] < hi)) {
                bins[j]++;
                found = true;
            }
        }
        if (!found) {
            bins[in.bin_count - 1]++;
        }
    }

    size_t max_bin_count = 0;
    for (size_t bin : bins) {
        if (bin > max_bin_count) {
            max_bin_count = bin;
        }
    }

    for (size_t i = 0; i < in.bin_count; i++) {
        cout << bins[i] << " |";
        size_t height = (max_bin_count <= MAX_ASTERISK) ? bins[i] : static_cast<size_t>(MAX_ASTERISK * (static_cast<double>(bins[i]) / max_bin_count));
        for (size_t j = 0; j < height; j++) {
            cout << "*";
        }
        cout << endl;
    }

    return 0;
}
